/**
 * Netwosix Web Admin - libagent
 * Copyright (C) 2006 netwosix team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * If you want to contact e-mail at info@netwosix.org
 */

#ifndef AGENT_H
#define AGENT_H

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#include <al.h>

/**
 * Version
 */
#define AGENT_VERSION_MAJOR                 0
#define AGENT_VERSION_MINOR                 0
#define AGENT_VERSION_MICRO                 6
#define AGENT_VERSION_NAME           libagent

#define AGENT_VERSION              AL_TO_VERSION(AGENT_VERSION_NAME,AGENT_VERSION_MAJOR,AGENT_VERSION_MINOR,AGENT_VERSION_MICRO)


#include "request.h"
#include "response.h"


/**
 * Process the request packet from stdin e write the response packet 
 * to stdout.
 *
 * @param request_packet request packet who response is based
 * @param func func to call for every request
 *
 * @return 0 if ok
 */
int agent_main(int argc, char ** argv, agent_response_create_func func);


/**
 * A default main implementation tha call a func for every request.
 *
 * @param func func to call for process request
 * @param agent_name name of agent
 */
#define AGENT_DEFAULT_MAIN(agent_name,func)       \
  int main(int argc, char ** argv)                \
  {                                               \
	int ret;                                  \
	openlog(agent_name, LOG_PID, LOG_DAEMON); \
	ret = agent_main(argc, argv, &func);      \
	closelog();                               \
	return ret;                               \
  }


#endif /* AGENT_H */
