/**
 * Netwosix Web Admin - libal
 * Copyright (C) 2006 netwosix team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * If you want to contact e-mail at info@netwosix.org
 */


#include "al.h"


/**
 */
#define AGENTD_STRING_INC       100


/**
 */
AlString * al_string_new(void)
{
	AlString * ret = al_new(AlString);

	ret->s = NULL;
	ret->len = 0;

	return ret;
}


/**
 */
void al_string_delete(AlString * string)
{
	al_return_if_fail(string);

	al_delete(string->s);
	al_delete(string);
}


/**
 */
void al_string_append_char(AlString * string, char c)
{
	al_return_if_fail(string);

	if (string->s == NULL)
	{
		string->s = (char*)malloc(sizeof(char) * AGENTD_STRING_INC);
		string->len = 0;
		string->allocated = AGENTD_STRING_INC;
	}

	if ((string->len + 1) >= string->allocated)
	{
		string->allocated += AGENTD_STRING_INC;
		string->s = (char*)realloc(string->s, sizeof(char) * string->allocated);
	}

	string->s[string->len] = c;
	string->s[++(string->len)] = '\0';
}


/**
 */
void al_string_delete_last_char(AlString * string)
{

	al_return_if_fail(string);

	if (string->s && string->len)
	{
		string->len--;
		string->s[((string->len) ? string->len-1 : 0)] = '\0';
	}

}


/**
 */
void al_string_set(AlString * string, const char * s)
{

	al_return_if_fail(string && s);

	al_delete(string->s);

	if (s)
	{
		string->s = al_strdup(s);
		string->len = strlen(s);
		string->allocated = string->len;
	}
	else
	{
		string->s = NULL;
		string->len = 0;
		string->allocated = 0;
	}
}
