/**
 * Netwosix Web Admin - libal
 * Copyright (C) 2006 netwosix team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * If you want to contact e-mail at info@netwosix.org
 */


#ifndef AL_STRING_H_
#define AL_STRING_H_



/**
 * Structure with a string
 */
struct _AlString
{

	char * s;
	int    len;
	int    allocated;

};

typedef struct _AlString AlString;


/**
 * Return the string
 *
 * @param string string
 *
 * @return the string
 */
#define al_string_get(string)                       (string)->s


/**
 */
#define al_string_len(string)                       (string)->len

/**
 * Create a new string.
 *
 * @return a new empty string
 */
AlString * al_string_new(void);


/**
 * Delete a string.
 *
 * @param string strind to delete
 */
void al_string_delete(AlString * string);


/**
 * Append a char to string
 *
 * @param string string
 * @param c char to append
 */
void al_string_append_char(AlString * string, char c);


/**
 * Delete last char of string
 *
 * @param string string
 */
void al_string_delete_last_char(AlString * string);


/**
 * Set the string
 *
 * @param string string 
 * @param s new string
 */
void al_string_set(AlString * string, const char * s);


#endif /* AL_STRING_H_ */
