/**
 * Netwosix Web Admin - libal
 * Copyright (C) 2006 netwosix team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * If you want to contact e-mail at info@netwosix.org
 */

#include "al.h"



/**
 */
AlString * al_read_file_by_name(const char * file_name)
{
	AlString * s;
	FILE         * file;


	al_return_val_if_fail (file_name, NULL);

	if ((file = fopen(file_name,"r")) == NULL) return NULL;

	s = al_read_file(file);

	fclose(file);

	return s;
}


/**
 */
AlString * al_read_file(FILE * file)
{
	AlString * s;
	char           buf;


	al_return_val_if_fail(file, NULL);

	s = al_string_new();
	while (!feof(file))
	{
		fread(&buf,1,1,file);
		if (feof(file)) break;

		al_string_append_char(s, buf);
	}


	return s;
}


/**
 */
void al_exit(int ret, const char * fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);

	if (fmt) vfprintf(stderr, fmt, ap);

	va_end(ap);

	exit(ret);
}
