/**
 * Netwosix Web Admin - libal
 * Copyright (C) 2006 netwosix team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * If you want to contact e-mail at info@netwosix.org
 */


#ifndef UTIL_H_
#define UTIL_H_


/**
 */
#define al_new(type)                     (type*)malloc(sizeof(type))


/**
 */
#define al_strdup(s)                     ((s) ? strdup(s) : NULL)


/**
 */
#define al_delete(p)                     do { if (p) free(p); p = NULL; } while(0)


/**
 */
#define al_return_if_fail(cnd)           if (!(cnd)) return;


/**
 */
#define al_return_val_if_fail(cnd,val)   if (!(cnd)) return val;


/**
 */
#ifdef AL_LOG
	#define al_log(args)                     do { printf args ; } while (0)
#else
	#define al_log(args)                     do {  } while (0)
#endif


/**
 * Read the content of a file.
 *
 * @param file_name filename
 *
 * @return the content of file or NULL if not found
 */
AlString * al_read_file_by_name(const char * file_name);


/**
 * Read the content of a file.
 *
 * @param file file
 *
 * @return the content of file or NULL if not found
 */
AlString * al_read_file(FILE * file);


/**
 * Print error on stderr and exit.
 *
 * @param ret ret value
 * @param fmt error msg
 */
void al_exit(int ret, const char * fmt, ...);


#endif /* UTIL_H_ */
